//Sprite size and color
float spritesize <string uiname="Sprite Size";> = 0.01f;
float4 spritecolor <string uiname="Sprite Color"; bool color=true;> = float4(1,1,1,1);

ByteAddressBuffer sobuffer;

Texture2D Sprite <string uiname="Sprite";>;
Texture2D ColTex <string uiname="ColTex";>;
StructuredBuffer<float4x4> tcd;
//Camera transforms


float4x4 tWVP :  WORLDVIEWPROJECTION;
float4x4 AlignParticle;
struct VS_IN
{
	uint ii : SV_InstanceID; //Object instance ID
    float4 PosO  : POSITION;
    float4 TexCd : TEXCOORD0;
};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;
    float4 TexCd: TEXCOORD0;
};



SamplerState g_samLinear : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

vs2ps VS(VS_IN input)
{
	//Here we just pass trough, gs, with expand the point
    vs2ps output;
	float x = asfloat(sobuffer.Load(input.ii * 12));
    float y = asfloat(sobuffer.Load(input.ii * 12 + 4));
    float z = asfloat(sobuffer.Load(input.ii * 12 + 8));
	float4 center = float4(x,y,z,0);
	
	output.TexCd = input.TexCd;
	output.PosWVP = mul(input.PosO+center,tWVP);
	
    return output;
}



float4 PS(vs2ps input) : SV_Target
{   
	float4 col = float4(ColTex.Sample(g_samLinear, input.TexCd.xy).rgb,1);
    float4 scol=Sprite.Sample( g_samLinear, input.TexCd.xy ) ;
	if(scol.r<0.1){discard;}
	col.a= (col.r+col.g+col.b)/3;
	return 1;//scol* spritecolor*col;
}


technique10 RenderParticles
{
    pass p0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );     
    }  
}


